/*:
# **Kapitel 4.8**
## Aufgabe 4 Regentropfen (Teil 4)
*/
/**
Stellt den Boden dar.
 
- author: Albert Wiedemann
- version: 1.0
*/
class Boden: Rechteck
{
    /**
    Setzt Position, Größe und Farbe
    */
    override init()
    {
        super.init()
        GrößeSetzen(breite: 800, höhe: 5)
        FarbeSetzen(farbe: "schwarz")
        PositionSetzen(x: 0, y: 516)
    }
}

/**
Simuliert dei Informatoin, dass der Boden gleich erreicht ist.
 
- author: Albert Wiedemann
- version: 1.0
*/
class Vorboden: Rechteck
{
    /**
    Setzt Position, Größe und Farbe
    */
    override init()
    {
        super.init()
        GrößeSetzen(breite: 800, höhe: 15)
        FarbeSetzen(farbe: "weiß")
        PositionSetzen(x: 0, y: 501)
    }
}

/*:
a\
Ändere den Konstruktor der Klasse REGENTROPFEN so ab, dass er
den Regentropfen zufällig in geeigneter Höhe und an beliebiger x-Koordinate platziert.*/
/**
Stellt einen Regentropfen in seinen verschiedenen Phasen dar.

- author: Albert Wiedemann
- version: 1.0
 */
class RegenTropfen: Figur
{
//#-editable-code
    /**
    Positioniert den Tropfen und legt den Fallwinkel fest
    Boden und Vorboden werden eingerichtet
    */
	override init()
	{
        super.init()
        Vorboden()
        Boden()
        FigurTropfenFestlegen()
        GanzNachVornBringen()
        PositionSetzen(x: 50, y: 50)
        WinkelSetzen(winkel: 270)
    }




//#-end-editable-code
    /**
    Stellt den Regentropfen im Fall dar
    */
    func FigurTropfenFestlegen()
    {
        self.EigeneFigurLöschen()
        self.FigurteilFestlegenDreieck(x1: -50, y1: 0, x2: 30, y2: -30, x3: 30, y3: 30, farbe: "blau")
        self.FigurteilFestlegenEllipse(x: 10, y: -30, breite: 40, höhe: 60, farbe: "blau")
    }

    /**
    Stellt den Regentropfen während des Aufpralls dar
    */
    func FlachWerden()
    {
        self.EigeneFigurLöschen()
        self.FigurteilFestlegenDreieck(x1: -50, y1: 0, x2: 30, y2: -30, x3: 30, y3: 30, farbe: "blau")
        self.FigurteilFestlegenRechteck(x: 30, y: -45, breite: 15, höhe: 90, farbe: "blau")
    }

    /**
    Stellt den Regentropfen als Pfütze dar
    */
    func PfützeWerden()
    {
        self.EigeneFigurLöschen()
        self.FigurteilFestlegenRechteck(x: 30, y: -45, breite: 15, höhe: 90, farbe: "blau")
    }
    /**
    Methode wird aufgerufen, wenn die Figur handeln soll.
    */
    override func AktionAusführen()
    {
        if Berührt(farbe: "schwarz")
        {
            PfützeWerden()
        }
        else
        {
            if Berührt(farbe: "weiß")
            {
                FlachWerden()
                Gehen(länge: 5)
            }
            else
            {
                Gehen(länge: 10)
            }
        }
    }
}
/*:
b\
Ergänze in deinem Projekt eine Klasse REGEN, in welcher – statt wie bisher in REGENTROPFEN – die Bodenelemente platziert
und dann 30 Regentropfen erzeugt werden.\
c\
Die Klasse REGEN soll nun von EREIGNISBEHANDLUNG erben. In der (überschriebenen) Methode *TaktImpulsAusführen* soll
jeweils ein neuer Regentropfen erzeugt werden. Der Konstruktor der Klasse REGEN soll keine Regentropfen mehr erzeugen,
dafür aber den Takt starten. Finde heraus, welche Methoden die Klasse EREIGNISBEHANDLUNG dazu aufgerufen werden muss.\
d\
Für Schnelle: Überschreibe nun auch die Methode *MausGeklickt*. Erzeuge jeweils einen Regentropfen an der Stelle, an
der die Maus geklickt wurde. Hinweis: Du musst dafür einen weiteren Konstruktor in der Klasse REGENTROPFEN ergänzen.*/
//#-editable-code
//#-end-editable-code

//#-editable-code
let tropfen = RegenTropfen()
//#-end-editable-code
        
