/*:
# **Kapitel 4.8**
## Aufgabe 6 Figur – Verrückte Reise (Teil 3)
*/
/**
Die Spielfigur der verückten Reise

- author: Albert Wiedemann
- version: 1.0
 */
class SpielFigur: Figur
{
//#-editable-code



//#-end-editable-code
    
    /**
    Bewegt die Figur 
    */
    override func AktionAusführen()
    {
        if Berührt(farbe: "schwarz")
        {
            Drehen(grad: 180)
            Gehen(länge: 40)
        }
        else if Berührt(farbe: "rot")
        {
            Drehen(grad: 5)
            Gehen(länge: 5)
        }
        else if Berührt(farbe: "grün")
        {
            Drehen(grad: -10)
            Gehen(länge: 5)
        }
        else if Berührt(farbe: "blau")
        {
            Drehen(grad: 15)
            Gehen(länge: 10)
        }
        else if Berührt(farbe: "gelb")
        {
            Drehen(grad: -5)
            Gehen(länge: 10)
        }
        else
        {
            Gehen(länge: 15)
        }
    }
    
    /**
    Steuert die Richtung der Spielfigur.
	- parameters:
        - taste: KeyCode der gedrückten Taste
     */
    override func SonderTasteGedrückt (taste: Int)
    {
        if taste == 123
        {
            Drehen(grad: 5)
        }
        else if taste == 124
        {
            Drehen(grad: -5)
        }
    }
    
}
/*:
Für die verrückte Reise der Figur kannst du in einer Klasse RAHMEN alle Hilfsflächen automatisch erzeugen.\
a\
Erstelle je eine Klasse RECHTECKBESSER, KREISBESSER und DREIECKBESSER, deren Konstruktor es
jeweils erlaubt, die Grafikfigur gleich mit gewünschter Größe, Position und Farbe anzulegen.\
b\
Erstelle eine Klasse RAHMEN, deren Konstruktor alle benötigten Hilfsflächen und das Figur-Objekt anlegt.
*/
//#-editable-code




//#-end-editable-code

//#-editable-code
let f=SpielFigur()
//#-end-editable-code
